# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.evaluation_function_return_type_enum import EvaluationFunctionReturnTypeEnum

class RequiredEvaluationFunctionResponse(TypedDict):
    # The description of the evaluation function.
    description: str

    # The name of the evaluation function.
    name: str

    # The code for the evaluation function. This code will be executed in a sandboxed environment.
    code: str

    # The type of the return value of the evaluation function.
    return_type: EvaluationFunctionReturnTypeEnum

    # Unique ID for the evaluation function. Starts with `evfn_`.
    id: str

    created_at: datetime

    updated_at: datetime

class OptionalEvaluationFunctionResponse(TypedDict, total=False):
    pass

class EvaluationFunctionResponse(RequiredEvaluationFunctionResponse, OptionalEvaluationFunctionResponse):
    pass
